public class Player {
    private Piece[] pieces = new Piece[16] ;
    private Color color ;

    public Piece[] getPieces() {
        return pieces ;
    }

    public Color getColor() {
        return color ;
    }

    public void setPieces(Piece[] pieces) {
        this.pieces = pieces ;
    }

    public void setColor(Color color) {
        this.color = color ;
    }

    public  Player(Color color) {
        this.color = color ;
        if (color == Color.WHITE) {
            for(int i=0 ; i<8 ; i++) {
                pieces[i] = new Pawn(new Cell(1,i), color) ;
            }
            pieces[8] = new Bishop(new Cell(0,2), color) ;
            pieces[9] = new Bishop(new Cell(0,5), color) ;
            pieces[10] = new Knight(new Cell(0,1), color) ;
            pieces[11] = new Knight(new Cell(0,6), color) ;
            pieces[12] = new Rook(new Cell(0,0), color) ;
            pieces[13] = new Rook(new Cell(0,7), color) ;
            pieces[14] = new King(new Cell(0,4), color) ;
            pieces[15] = new Queen(new Cell(0,3), color) ;

        }
        else {
            for(int i=0 ; i<8 ; i++){
                pieces[i] = new Pawn(new Cell(6,i), color) ;
            }
            pieces[8] = new Bishop(new Cell(7,2), color) ;
            pieces[9] = new Bishop(new Cell(7,5), color) ;
            pieces[10] = new Knight(new Cell(7,1), color) ;
            pieces[11] = new Knight(new Cell(7,6), color) ;
            pieces[12] = new Rook(new Cell(7,0), color) ;
            pieces[13] = new Rook(new Cell(7,7), color) ;
            pieces[14] = new King(new Cell(7,4), color) ;
            pieces[15] = new Queen(new Cell(7,3), color) ;
        }
    }
}